-- written by DaddelZeit
-- DO NOT USE ANY PART OF THIS CODE WITHOUT EXPLICIT PERMISSION

local M = {}

local lastValue = 0
local value = 0
local updateLightStateTimer = 0
-- to avoid all vehicles calling at the same time
local updateStateThreshold = 0.5+(math.random()*1.5)
local lightUpdatedTimer = -1
local manuallyTurnedOff = false

local function updateAutoHeadlights(val)
    if manuallyTurnedOff then return end
    value = val

    if (lastValue == 2 and value == 1) then
        print("just went back to low")
        lightUpdatedTimer = 4
    end

    if (value == 2 and lightUpdatedTimer == -1) or (value < 2) then
        electrics.setLightsState(value)
        lastValue = value
    end
end

local function updateGFX(dt)
    updateLightStateTimer = updateLightStateTimer + dt
    if updateLightStateTimer >= updateStateThreshold then
        obj:queueGameEngineLua("if autoHeadlightsZeit then autoHeadlightsZeit.updateVehData("..obj:getId()..","..math.min(electrics.values.brakelights+electrics.values.lowhighbeam+electrics.values.highbeam,2)..","..obj:getDirectionVector().x..","..obj:getDirectionVector().y..","..obj:getDirectionVector().z..") end")
        updateLightStateTimer = 0
    end

    if lightUpdatedTimer > -1 then
        lightUpdatedTimer=lightUpdatedTimer-dt
        if lightUpdatedTimer <= 0 then
            lightUpdatedTimer = -1
            if electrics.values.lowhighbeam == 1 then
                updateAutoHeadlights(value)
            end
        end
    end

    if electrics.values.lowhighbeam == 0 and lastValue ~= 0 then
        manuallyTurnedOff = true
    elseif manuallyTurnedOff and electrics.values.lowhighbeam == 1 then
        manuallyTurnedOff = false
    end
end

local function onExtensionLoaded()
    obj:queueGameEngineLua([[if not autoHeadlightsZeit then extensions.load("autoHeadlightsZeit") end]])
    obj:queueGameEngineLua("if autoHeadlightsZeit then autoHeadlightsZeit.registerVeh("..obj:getId()..") end") -- register the car
    manuallyTurnedOff = false
end

M.updateGFX = updateGFX
M.onExtensionLoaded = onExtensionLoaded
M.updateAutoHeadlights = updateAutoHeadlights

return M